/***************************************************************************
 *   Copyright (C) 2005 by JSRiera			                   *
 *   http://www.xtec.cat/dnee/udc/english/main.html		           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#include "CGame.h"

void CGame::Init(char *config, int full_screen, int f_v, int f_h)
{
	int ok;

	if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 )
	{
		printf("Unable to init SDL: %s\n", SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);

	if (full_screen)
		screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_HWPALETTE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
	else
		screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_HWPALETTE|SDL_DOUBLEBUF);

	if ( screen == NULL )
	{
		printf("Unable to set 640x480 video: %s\n", SDL_GetError());
		exit(1);
	}

	if (Mix_OpenAudio(44100, AUDIO_S16SYS, 1, 2048) <0)
	{
		printf("Unable to set Audio.Error %s\n", SDL_GetError());
		exit(2);
	}

	SDL_WM_SetCaption("Simuove", "Simuove");

	sprintf(fgame, "%s", config);
	
	ok = cip.InitializeWebcam (0, f_v, f_h);
	if (ok < 0 ) { printf("No es troba la webcam\n"); exit (-1); }
	

	printf("Carregant menu\n");

	right_arrow.init(screen, "data/arrow");
	left_arrow.init(screen, "data/arrow");
	tick.init (screen, "data/tick");

	printf("Fonts i menu carregats correctament\n");

	done = 1;
	// per seleccionar mode blanc i negre
	bn = 0;

	estat = INICI;
	ResetTemps ();


	left_arrow.set (500, 250);
	right_arrow.set (50,250);
	tick.set (350, 50);
	a = 1;
	b = 1;
	which = -1;

	// initialize params
	for (int i=0;i<MAX_SPRITE; i++)
		count_up[i] = 0;

	// Reset sequences
	for (int c=0; c<MAX_SEQ; c++)
		for (int d=0; d<MAX_SPRITE; d++)
			bseq[c][d] = 0;


	joc_actual = 1;

	numrf = -1;

	printf("Carregant parametres joc\n");
	LoadAnimations ();
	printf("Parametres joc carregats correctament\n");


	ftHandle = NULL;
	// Initialize RF device
	ftStatus = FT_Open(0, &ftHandle);
	if(ftStatus != FT_OK) {
			// FT_Open failed
		printf("Error opening RF device\n");
	}

	
}

void CGame::ResetTemps ()
{
	sdlgt=0.0;
	dt=0.0;              
	td=0;
	td2=0;     
	blast=0;
}

void CGame::LoadGame (int game )
{
	char buffer[255];
	char name[255];
	char buf[80];
	char buf1[80];
	char buf2[80];
	FILE *fp;
	int jocs1;
	int  sx, sy;
	

	if((fp=fopen(fgame, "r")) == NULL)
	//if((fp=fopen("omple.txt", "r")) == NULL)
	{
		printf("ERROR opening file %s\n\n", fgame);
	}

	// saltem 3 primeres linies
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  

	// obtenim num jocs
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%i", &jocs1);  
	
	printf("jocs:%d\n", jocs1);

	// saltem imatges presentacions
	for (int j=0; j<jocs1; j++) {
		printf("volta bucle: %d\n", j);
		fgets(buffer, 255, fp);
		sscanf(buffer, "%s", buf);  }

	printf ("game: %d\n", game);

	for (int i=0; i<game; i++)
	{
	// Msica
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	int err = mus_joc.LoadMusic(buf);
	if (!err) {
		printf("Error loading music %s\n", buffer);
		exit (0);
	}
	printf("Musica game: %s\n", buffer);

	// Num. sprites
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%d", &num_sprites); 
	printf("sprites: %d\n", num_sprites);

	count = 0;

	while(!feof(fp) && count<num_sprites)
	{
		fgets(buffer, 255, fp);
		if(buffer[0] != '#' && buffer[0] != '\r' && buffer[0] != '\0' && buffer[0] != '\n' && strlen(buffer) != 0)
		{
			sscanf(buffer, "%s %d %d %d %d %d %d", name, &sx, &sy, &volinc[count], &voltes[count],
					&pulse[count]);
			printf("nom: %s\n", name);
			printf("posx: %d\n", sx);
			printf("posy: %d\n", sy);
			printf("voltes increment: %d\n", volinc[count]);
			printf("voltes: %d\n", voltes[count]);
			printf("pulse: %d\n", pulse[count]);
			sprite[count].init(screen, name);
			sprite[count].set((float)sx, (float)sy);
			sprite[count].stopAnim();
			fn[count] = 0;
			count_fn[count] = 0;
			count++;
		}
	}


	// ID sequence
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%d %d", &idseq, &salta[0]); 
	printf("Sequence ID: %d\n", idseq);

	// all sprite frames must be equal
	if (idseq == -2)
	{
		for (int q=0; q<MAX_SEQ; q++)
			for (int r=0; r<num_sprites; r++)
				s[q][r] = q;

		// Efecte de so
		fgets(buffer, 255, fp);  
		sscanf(buffer, "%s", buf);  
		int err2 = efecte[0].LoadEffect(buf);
		if (!err2) {
			printf("Error loading music %s\n", buffer);
			exit (0);
		}
		printf("Efecte game: %s\n", buffer);

		// Imatge ok
		fgets(buffer, 255, fp);  
		sscanf(buffer, "%s", buf);  
		printf("Premi game: %s\n", buffer);
		ok[0] = ImageLoad(buf);

		// start with random frames
		for (int c = 0; c<num_sprites; c++)
			fn[c] = rand()%sprite[c].getNumFrames();
			//sprite[c].setFrame(rand()%sprite[c].getNumFrames());

	}

	// no sequence, we can read sound and image
	else if (idseq == -1)
	{
		// Efecte de so
		fgets(buffer, 255, fp);  
		sscanf(buffer, "%s", buf);  
		int err2 = efecte[0].LoadEffect(buf);
		if (!err2) {
			printf("Error loading music %s\n", buffer);
			exit (0);
		}
		printf("Effect game: %s\n", buffer);
	
		// Imatge ok
		fgets(buffer, 255, fp);  
		sscanf(buffer, "%s", buf);  
		printf("Premi game: %s\n", buffer);
		ok[0] = ImageLoad(buf);

		// Initialize structure s
		for (int u = 0; u<MAX_SEQ; u++)
			for (int v = 0; v<MAX_SPRITE; v++)
				s[u][v] = 0;
	}
	// whatever number is, we read sequence and sound+image
	else
	{
		int p = 0;
		while (p < idseq)
		{
			fgets(buffer, 255, fp);
			sscanf(buffer, "%d %d %d %d %d %d %d %d %s %s %d", 
				&s[p][0], &s[p][1], &s[p][2], &s[p][3], &s[p][4], &s[p][5], &s[p][6], &s[p][7],
				buf1, buf2, &salta[p]);
	

			ok[p] = ImageLoad(buf1);
			efecte[p].LoadEffect(buf2);

			p++;
		}
	}
	
	}
	
	fclose(fp);	

}

void CGame::LoadAnimations ()
{
	char buffer[255];
	char buf[80];
	FILE *fp;

	if((fp=fopen(fgame, "r")) == NULL)
	//if((fp=fopen("omple.txt", "r")) == NULL)
	{
		printf("ERROR opening file %s\n\n", fgame);
	}

	// version
	fgets(buffer, 255, fp);  

	printf("\t 1. %s", buffer);

	// Imatge inici
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	ini = ImageLoad (buf);
	printf("\t 2. %s", buffer);

	// Msica
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%s", buf);  
	int err = mus_menu.LoadMusic(buf);
	if (!err) {
		printf("Error loading music %s\n", buffer);
		exit (0);
	}
	printf("\t 3. %s", buffer);

	// obtenim num jocs
	fgets(buffer, 255, fp);  
	sscanf(buffer, "%i", &jocs);  
	printf("\t jocs: %i", jocs);

	for (int i=0; i<jocs; i++)
	{
		fgets(buffer, 255, fp);  
		sscanf(buffer, "%s", buf);  
		vec_jocs[i] = ImageLoad(buf);
		printf("\t %s", buffer);
	}

	fclose(fp);	

	sleep (1);

	LoadGame (1);
	
}


SDL_Surface* CGame::ImageLoad(char *file)
{
	SDL_Surface *temp1, *temp2;
	temp1 = IMG_Load(file);
	if (!temp1) {
		printf("Error loading image %s\n", file);
		exit (0);
	}
	temp2 = SDL_DisplayFormat(temp1);
	SDL_FreeSurface(temp1);

	return temp2;
}

void CGame::ConvertBGRToRGB(IplImage * image) {
	
	char color;
		
	for (int i=0; i < image->width*image->height*3; i+=3) {
			
		color      = image->imageData[i];
		image->imageData[i]   = image->imageData[i+2];
		image->imageData[i+2] = color;
	}					
}


SDL_Surface* CGame::FrameLoad (IplImage *image)
{
	SDL_Surface *temp1;
	SDL_Surface *temp2;
    Uint32 rmask, gmask, bmask, amask;

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif

	ConvertBGRToRGB(image);

	temp1 = SDL_CreateRGBSurfaceFrom(image->imageData, 640, 480, 24, 1920, 
                                      rmask, gmask, bmask, amask);

	
	temp2 = SDL_DisplayFormat(temp1);
	SDL_FreeSurface(temp1);
	return temp2;
}

void CGame::DrawIMG(SDL_Surface *img, int x, int y)
{
	SDL_Rect dest;
	dest.x = x;
	dest.y = y;
	SDL_BlitSurface(img, NULL, screen, &dest);
}

// Blit a portion of an image on the screen surface
void CGame::DrawIMG(SDL_Surface *img, int x, int y,
                        int w, int h, int x2, int y2)
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_Rect dest2;
  dest2.x = x2;
  dest2.y = y2;
  dest2.w = w;
  dest2.h = h;
  SDL_BlitSurface(img, &dest2, screen, &dest);
}

void CGame::ProcessarEvent()
{
	SDL_Event event;
	while ( SDL_PollEvent(&event) )
	{
		SDL_GetMouseState(&x, &y);
		if ( event.type == SDL_QUIT )  { done = 0; }

		if ( event.type == SDL_KEYDOWN ) {
			if ( (event.key.keysym.sym == SDLK_RETURN) && (estat == MENU) ) estat = TRANSICIO;
			if ( event.key.keysym.sym == SDLK_ESCAPE ) {
				if (estat == MENU) { done = 0; }
				else
				{
					estat = MENU;
					mus_joc.StopMusic ();
					mus_menu.PlayMusic (-1);
				}
			}
			// change to black&white mode
			if (event.key.keysym.sym == 'b' )
			{
				if (bn == 1) bn = 0;
				else bn = 1;
			}
			if ( event.key.keysym.sym == SDLK_LEFT )
			{
				if (joc_actual <= 1) joc_actual = jocs;
				else joc_actual--;
			}
			if ( event.key.keysym.sym == SDLK_RIGHT )
			{
				if (joc_actual >= jocs) joc_actual = 1;
				else joc_actual++;
			}
		}
		// controlling menu options
		if ( event.type == SDL_MOUSEBUTTONDOWN)
		{
			if ( (estat == MENU) &&  
					(x>left_arrow.getx()) && (x<left_arrow.getx()+left_arrow.getw()) &&
					(y > left_arrow.gety()) && (y<left_arrow.gety()+left_arrow.geth()))
			{
				if (joc_actual >= jocs) joc_actual=1;
				else joc_actual++;
			}
			if ((estat == MENU) &&
					(x>right_arrow.getx()) && (x<right_arrow.getx()+right_arrow.getw()) &&
					(y > right_arrow.gety()) && (y<right_arrow.gety()+right_arrow.geth()))
			{
				if (joc_actual <= 1) joc_actual = jocs;
				else joc_actual--;
			}
			if ((estat == MENU) &&
					(x>tick.getx()) && (x<tick.getx()+tick.getw()) &&
					(y > tick.gety()) && (y<tick.gety()+tick.geth()))
			{
				estat = TRANSICIO; 
			}
			for (int i=0; i<num_sprites;i++)
			{
				if ((x>sprite[i].getx()) && (x<sprite[i].getx()+sprite[i].getw()) &&
					(y > sprite[i].gety()) && (y<sprite[i].gety()+sprite[i].geth()))
				{ 
					if (fn[i] < sprite[i].getNumFrames ()-1) fn[i]++;
				}
			}

		}
	}
}

void CGame::Joc()
{

	cip.CaptureFrame (640, 480);
	cip.CalculateMovement ();

	if (bn == 0) 
	{
		IplImage *data = cip.GetPicture (IMAGE, 0);
		fondo = FrameLoad(data);
	}
	//if (bn == 1)
	else
	{
		IplImage *bg = cip.GetPicture (MOVE_BKG, 0);
		fondo = FrameLoad(bg);
	}

	// 
	// State Machine
	//

	if ( estat == INICI )
	{
		DrawIMG(ini, 0, 0);
		if (TempsTranscorregut (5000))
		{
			mus_menu.PlayMusic (-1);
			estat = MENU; 
		}
	}
	else if ( estat == JUGANT )
	{

		// Capture RF data if exists
		if (ftHandle)
		{
			RxBytes = 1;
			numrf = -1;
			FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
			if (RxBytes > 0) {
				ftStatus = FT_Read(ftHandle,RxBuffer,RxBytes,&BytesReceived);
	            if (ftStatus == FT_OK) {
					if (BytesReceived == RxBytes) {
			  			// FT_Read OK
						numrf = RxBuffer[0];
					}
	             }
		         else {
			          // FT_Read Failed
					 printf("Nothing to read\n");
				 }
	        } 
		}

		DrawIMG(fondo, 0, 0);

		for (int i=0; i<num_sprites;i++)
		{
			// set the sprite frame
			sprite[i].setFrame(fn[i]);

			if (numrf == pulse[i])
			{
				fn[i]++;
				if (fn[i] == sprite[i].getNumFrames ()) { 
					fn[i] = 0;
				}
				numrf = -1;
			}


			if (cip.GetPixelsNoZero((int)sprite[i].getx(), (int)sprite[i].gety(), (int)sprite[i].getw(), (int)sprite[i].geth()) > 0) 
			{ 
				// hem d'entrar volinc vegades per avancar sequencia
				if ( count_up[i] > volinc[i] )
				{
					count_up[i] = 0;
					fn[i]++;
					
					// play sound associated to frame if it exists
					sprite[i].playSound(fn[i], 0);
					
					if (fn[i] == sprite[i].getNumFrames ()) { 
						count_fn[i] = 0;
						fn[i] = 0;
	
						// we arrived to the last frame
						if (idseq == -1) estat = PREMI;

					}
				}
				count_up[i]++;
			}
			else 
			{
				if ((count_fn[i] > voltes[i]) && (fn[i] > 0)) {count_fn[i] = 0;fn[i]--; }
				else count_fn[i]++;
			}

			// set the sprite frame
			sprite[i].setFrame(fn[i]);

			// realize loop until max value reached
			if (idseq == -2)
			{
				for (int is =0; is <MAX_SEQ; is++)
				{
					if ((sprite[i].getFrame() == s[is][i]) )
					{
						bseq[is][i] = 1;
					} else bseq[is][i] = 0;
				}
			}

			// only enter if we have a finite number of sequences
			for (int is =0; is <idseq; is++)
			{
				if ((sprite[i].getFrame() == s[is][i]) )
				{
					bseq[is][i] = 1;
				} else bseq[is][i] = 0;
			}

			// draw the sprites
			sprite[i].draw ();

		}

		// which sequence is accomplishing	
		which = CompleixSeq (); 
		if (which != -1)
			estat = PREMI;

	}
	else if ( estat == PREMI )
	{
		//if ((idseq == -2) || (idseq == -1))
		if (idseq == -1)
		{
			if (salta[0] == -1)
			{
				// efecte so
				efecte[0].PlayEffect (0);
				// mostrar imatge
				DrawIMG(ok[0], 0, 0);
				SDL_Flip(screen);
				sleep (1);
				estat = JUGANT;
			}
			else
			{
				// jump to another activity
				estat = TRANSICIO;
				joc_actual = salta[0];
			}
		}
		else if (idseq == -2)
		{
			if (salta[0] == -1) 
			{
				// mostrar imatge
				DrawIMG(fondo, 0, 0);
	
				// mostrar imatge
				DrawIMG(ok[0], 320-ok[0]->w/2, 240-ok[0]->h/2);

				// posar frame sprites a 0 
				for (int k=0; k<num_sprites; k++)
				{
					sprite[k].draw();
					fn[k] = 0;
				}
	
				SDL_Flip(screen);

				// efecte so
				efecte[0].PlayEffect (0);

				// Wait some time until jump next state
				sleep (1);
				estat = JUGANT;
			}
			else
			{
				// jump to another activity
				estat = TRANSICIO;
				joc_actual = salta[0];
			}
			// start with random frames to not coincide in the beginning
			for (int c = 0; c<num_sprites; c++)
				fn[c] = rand()%sprite[c].getNumFrames();
		}
		else
		{
			if (salta[which] == -1)
			{
				// mostrar imatge
				DrawIMG(fondo, 0, 0);

				// posar frame sprites a 0 
				for (int k=0; k<num_sprites; k++)
				{
					sprite[k].draw();
					fn[k] = 0;
				}

				// draw ok image
				DrawIMG(ok[which], 320-(ok[which]->w/2), 240-(ok[which]->h/2));
	
				SDL_Flip(screen);

				// play effect
				efecte[which].PlayEffect (0);
	
				// Wait some time until jump next state
				sleep(1);
				estat = JUGANT;
			}
			else
			{
				// jump to another activity
				estat = TRANSICIO;
				joc_actual = salta[which];
			}

		}
		// reset sequence to false
		for (int a =0; a<MAX_SEQ; a++) 
			for (int b=0; b<MAX_SPRITE; b++) 
				bseq[a][b] = 0;

		//estat = JUGANT;
	}

	else if ( estat == OPCIONS )
	{
		//DrawIMG(fondo, 0, 0);
		if (TempsTranscorregut (3000))	estat = JUGANT; 
	}
	else if ( estat == MENU )
	{
		DrawIMG(fondo, 0, 0);

		left_arrow.setFrame(1);
		left_arrow.draw ();

		right_arrow.setFrame(0);
		right_arrow.draw ();

		tick.setFrame (0);
		tick.draw ();


		// aqui, carregar i descarregar cada opcio de joc
		//if (imgproc.NumPixelsNoZero(tick.getx(), tick.gety(), tick.getw(), tick.geth()) > 10) 
		if (cip.GetPixelsNoZero((int)tick.getx(), (int)tick.gety(), (int)tick.getw(), (int)tick.geth()) > 0) 
		{ 
			SDL_Rect rect1 = {350, 50, c+=3, tick.geth ()};
			SDL_FillRect(screen, &rect1, 0x00FF00);
			if ( c > tick.getw() ) { c = 1; estat = TRANSICIO; }
		}
		else
		{
			SDL_Rect rect1 = {350, 50, c-=1, tick.geth ()};
			SDL_FillRect(screen, &rect1, 0x00FF00);
			if ( c < 1 ) c = 1;
		}

		//if (imgproc.NumPixelsNoZero(left_arrow.getx(), left_arrow.gety(), left_arrow.getw(), left_arrow.geth()) > 10) 
		if (cip.GetPixelsNoZero((int)left_arrow.getx(), (int)left_arrow.gety(), (int)left_arrow.getw(), (int)left_arrow.geth()) > 0) 
		{ 
			SDL_Rect rect1 = {500, 250, a+=3, left_arrow.geth ()};
			SDL_FillRect(screen, &rect1, 0x00FF00);
			if ( a > left_arrow.getw() ) 
			{
				//a = left_arrow.getw(); 
				a = 1;
				if (joc_actual >= jocs) joc_actual=1;
				else joc_actual++;
			}
		}
		else
		{
			SDL_Rect rect1 = {500, 250, a-=1, left_arrow.geth ()};
			SDL_FillRect(screen, &rect1, 0x00FF00);
			if ( a < 1 ) a = 1;
		}

		//if (imgproc.NumPixelsNoZero(right_arrow.getx(), right_arrow.gety(), right_arrow.getw(), right_arrow.geth()) > 10) 
		if (cip.GetPixelsNoZero((int)right_arrow.getx(), (int)right_arrow.gety(), (int)right_arrow.getw(), (int)right_arrow.geth()) > 0) 
		{ 
			b+=3;
			SDL_Rect rect2 = {(short)right_arrow.getx()+right_arrow.getw()-b, 250, b, (short)right_arrow.geth ()};
			SDL_FillRect(screen, &rect2, 0x00FF00);
			if ( b > right_arrow.getw() )
			{
				//b = right_arrow.getw();
				b = 1;
				if (joc_actual <= 1) joc_actual = jocs;
				else joc_actual--;
			}
		}
		else
		{
			b-=1;
			SDL_Rect rect2 = {(short)right_arrow.getx()+right_arrow.getw()-b, 250, b, (short)right_arrow.geth ()};
			SDL_FillRect(screen, &rect2, 0x00FF00);
			if ( b < 1 ) b = 1;
		}

		DrawIMG (vec_jocs[joc_actual-1], 250, 240);
	}

	else if ( estat == TRANSICIO )
	{
		SDL_Rect brect = {0, 0, 640, 480};
		SDL_FillRect(screen, &brect, 0x000000);
		// potser escriure lletres de carregant dades
		SDL_Flip(screen);
		mus_menu.StopMusic ();
		sleep (1);
		LoadGame (joc_actual);
		sleep (1);
		mus_joc.PlayMusic (-1);
		estat = JUGANT;
		
	}
	else printf("estat no definit\n");

	// Actualize screen
	SDL_Flip(screen);
	if (fondo) SDL_FreeSurface(fondo);

}

int CGame::CompleixSeq ()
{
	int limit;

	// variable limit change in function of idseq
	if (idseq == -2) limit = MAX_SEQ;
	else limit = idseq;

	int res = -1;
	for (int i=0;i<limit;i++)
		for (int j = 0; j<num_sprites; j++)
		{
			// not accomplishes sequence, exit for
			if (bseq[i][j] == 0) break;
			// hem arribat al final seq i es tot 1's
			if ((bseq[i][j] == 1) && (j == num_sprites-1)) res = i; 			
		}
			
	return res;
}

int CGame::Finalitzar ()
{
	return done;
}

void CGame::Espera (int temps)
{
	SDL_Delay(temps);
}

void CGame::FreeJoc()
{
	// close RF device
	if (ftHandle)
		FT_Close (ftHandle);

	SDL_FreeSurface(ini);
	SDL_FreeSurface(fondo);
	for (int i=0; i<num_sprites; i++) SDL_FreeSurface(ok[i]);
	SDL_FreeSurface(screen);
}

// time in milliseconds
// return true if passed more than temps milliseconds
int CGame::TempsTranscorregut (int temps)
{
    td2=SDL_GetTicks();
	dt=((float)(td2-td))*0.1;
    td=td2;
	sdlgt+=dt*10;
	if (sdlgt-blast>temps)
	{
		blast=(Uint32)sdlgt;
		return 1;
	} else return 0;
}

CGame::~CGame()
{
}

