/***************************************************************************
 *   Copyright (C) 2005 by JSRiera							               *
 *   http://www.xtec.cat/dnee/udc/english/main.html					       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#ifndef CGAME_H
#define CGAME_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <SDL.h>
#include "SDL_image.h"
#include "CSprite.h"
#include "CImgProc.h"
#include "CSound.h"
#include "ftd2xx.h"


#define MOSQUITS 8
#define MAX_SPRITE 8
#define MAX_JOCS 8
#define MAX_SEQ 8

enum EstatJoc { INICI, OPCIONS, MENU, JUGANT, TRANSICIO, CREDITS, PREMI };

class CGame 
{
public:
	void Init(char *config, int full_screen, int f_v, int f_h);
	void Joc();
	void ProcessarEvent();
	void FreeJoc();
	int  Finalitzar();
	void Espera(int temps);
	~CGame();

protected:

	SDL_Surface* ImageLoad(char *file);
	SDL_Surface* FrameLoad(IplImage *image);
	void ConvertBGRToRGB(IplImage * image);
	void DrawIMG(SDL_Surface *img, int x, int y);
	void DrawIMG(SDL_Surface *img, int x, int y, int w, int h, int x2, int y2);
	int  TempsTranscorregut(int temps);
	void ResetTemps ();
	void LoadAnimations ();
	int  CompleixSeq ();
	void LoadGame (int game);

private:
	SDL_Surface *screen;
	SDL_Surface *ini;
	SDL_Surface *ok[MAX_SEQ];
	SDL_Surface *fondo;
	CSprite sprite[MAX_SPRITE];
	CSprite left_arrow;
	CSprite right_arrow;
	CSprite tick;
	CImgProc cip;
	char fgame[40];
	CSound mus_joc, mus_menu;
	CSound efecte[MAX_SEQ];
	int count_fn[MAX_SPRITE];
	int count_up[MAX_SPRITE];
	int done;
	EstatJoc estat;
	float sdlgt;
	float dt;              
	int td,td2;     
	Uint32 blast;
	int x, y;		// posicio mouse
	int fn[MAX_SPRITE];
	int count;
	int  num_sprites;
	int bn;
	int voltes[MAX_SPRITE];
	int volinc[MAX_SPRITE];
	bool bseq [MAX_SEQ][MAX_SPRITE];
	int a, b, c;
	int jocs, joc_actual;
	SDL_Surface *vec_jocs[MAX_JOCS];
	// codes for using it with rf module
	int pulse[MAX_SPRITE];

    FT_HANDLE ftHandle;
    FT_STATUS ftStatus;
    DWORD RxBytes;
    DWORD BytesReceived;
    char RxBuffer[256];
    DWORD EventDWord;
    DWORD TxBytes;

	int numrf;
	// Sequence identifier
	int idseq;
	// matrix containig sequences
	int s[MAX_SEQ][MAX_SPRITE];
	int which;
	int salta[MAX_SEQ]; // si fem una seq correcta saltem a una altra activitat

};

#endif
