/***************************************************************************
 *   Copyright (C) 2004 by Balzs "Goldberg" Pter                         *
 *   goldberg@localhost                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#include "CSound.h"

// ============
// konstruktor
// ============
CSound::CSound() {

	music = NULL;
	effect = NULL;
	
	channelID	 = -1;
}

// ===============
// 2. konstruktor
// ================
CSound::CSound(char* soundfile, int mode) {
	
	// zene
	if ( mode == MUSIC_MODE ) {
	
		music = Mix_LoadMUS(soundfile);
	}
	 else // effekt
	 	  {
	 		effect = Mix_LoadWAV(soundfile);
	 }
		
	channelID	 = -1;	
}

// ==============
// destruktor
// ==============
CSound::~CSound() {
	
	if (music) {
		StopMusic();
		Mix_FreeMusic(music);
	}
	
	if (effect) {
		 // StopEffect();
		 Mix_FreeChunk(effect);
	}
}

// =========================
// zene betoltese
// =========================
int CSound::LoadMusic(char* soundfile) {
		
	music = Mix_LoadMUS(soundfile);	
	return (music!=NULL);
}

// ==========================
// effekt betoltese
// ==========================
int CSound::LoadEffect(char* soundfile) {
		
	effect = Mix_LoadWAV(soundfile);
	if(!effect) 
    printf("Mix_LoadWAV: %s\n", Mix_GetError());	
	return (effect!=NULL);
}

void CSound::NoLoadEffect ()
{
	effect = NULL;
}

// =================
// zene lejtszsa
// =================
void CSound::PlayMusic(int repeat) {

	// zenet csak ha vege van akkor lehet ujra lejatszani (hacsak a repeat nem -1)
	if (music!=NULL) {
			
		Mix_PlayMusic( music, repeat );
		Mix_HookMusicFinished( MusicDone );
	}
	
}

// ===================
// effekt lejtszsa
// ===================
void CSound::PlayEffect(int repeat) {
		
	// effektet akarhanyszor le lehet jatszani
	if ( effect!=NULL ) {
		
		channelID = Mix_PlayChannel(-1, effect, repeat );
		Mix_ChannelFinished( EffectDone );		
	}
}

// ===============
// zene lelltsa
// ===============
void CSound::StopMusic() {

	if ( music!=NULL ) 	
		Mix_HaltMusic();
}

// ==================
// effect lelltsa
// ==================
void CSound::StopEffect() {

	if ( effect!=NULL )
		Mix_HaltChannel( channelID );
}

// ================================= NEM AZ OSZTLY METDUSAI ============================

// =============================
// zene vgt ellenrz callback
// =============================
void MusicDone() {
	
	Mix_HaltMusic();
} 

// =============================
// effekt vgt ellenrz callback
// =============================
void EffectDone(int channel) {

	Mix_HaltChannel( channel );
} 
