/***************************************************************************
 *   Copyright (C) 2004 by Balzs "Goldberg" Pter                         *
 *   goldberg@localhost                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   YOU CAN NOT USE THIS SOURCE FILE OR MODIFIED VERSION FOR ANY          *
 *   COMMERCIAL PRODUCTS!                                                  *
 *                                                                         *
 ***************************************************************************/
#ifndef CSOUND_H
#define CSOUND_H

#define MUSIC_MODE 	0
#define SOUND_MODE 	1

#include <SDL_mixer.h>


/**
@author Balzs "Goldberg" Pter
*/

void MusicDone();		// ha vege van a zenenek
void EffectDone(int);	// ha vege van a hangeffektnek						

class CSound{
	
		
	private:
			Mix_Music *music;		// betoltott zene
			Mix_Chunk *effect;	 	// betoltott hang effekt
									
			int		  channelID;

	public:
    	
		CSound();			// konstruktor
		CSound(char*, int);		// konstruktor, amely be is tolti az adott zenefilet
    	~CSound();				// destruktor
		
		int LoadMusic(char*);
		int LoadEffect(char*);		// adott zenefilet tolti be		
		void PlayMusic(int);
		void PlayEffect(int);		// hanglejatszas elinditasa, milyen modon tortenjen)		
		void StopMusic();		
		void StopEffect();			// hanglejatszas leallitasa
		void SetChannels(int, int); // bal-jobb oldali csatorna hangerejenek allitasa
		void NoLoadEffect (); // effect = NULL
		
};

#endif
