/*
  CSprite.h
  Header for the simple SDL sprite class.
  Made by Marius Andra 2001
  http://cone3d.gamedev.net

  You can use the code for anything you like.
  Even in a commercial project.
  But please let me know where it ends up.
  I'm just curious. That's all.

  Classe modificada per J.S.Riera. 2005.
  S'ha eliminat la dependncia de la classe CSpriteBase
  Ara tamb es pot carregar qualsevol tipus d'imatge.
  Afegit suport per alpha channel
*/

#ifndef CSPRITE_H
#define CSPRITE_H

#include <SDL.h>

//#include "CSpriteBase.h"
#include "SDL_image.h"
#include "CSound.h"

struct CSpriteFrame
{
  SDL_Surface *image;
  int pause;
};

/*struct CSpriteBase
{

};*/

class CSprite
{

public:

	CSprite(); 
	~CSprite() {};
	int init(SDL_Surface *screen, char *dir);
	void draw();
	void drawA(int alpha);
	void clearBG();
	void updateBG();

	void setFrame(int nr) { mFrame = nr; }
	int getFrame() { return mFrame; }
	int getNumFrames () { return mNumframes; }
	int getFixFrame () { return mfixframe; }
	void setFixFrame (int frame) { mfixframe = frame; }

	void setSpeed(float nr) { mSpeed = nr; }
	float getSpeed() { return mSpeed; }

	void toggleAnim() { mAnimating = !mAnimating; }
	void startAnim() { mAnimating = 1; }
	void stopAnim() { mAnimating = 0; }
	void rewind() { mFrame = 0; }

	void xadd(float nr) { mX+=nr; }
	void yadd(float nr) { mY+=nr; }
	void xset(float nr) { mX=nr; }
	void yset(float nr) { mY=nr; }
	void set(float xx, float yy) { mX=xx; mY=yy; }

	float getx() {return mX;}
	float gety() {return mY;}
  
	int getw() {return mAnim[0].image->w;}
	int geth() {return mAnim[0].image->h;}

	int esDins (int x, int y);

	SDL_Surface* ImageLoad(char *file);
	void DrawIMG(SDL_Surface *img, int x, int y, SDL_Surface *screen);
	void DrawIMG(SDL_Surface *img, int x, int y,
                        int w, int h, int x2, int y2, SDL_Surface *screen);
	SDL_Surface* FrameLoad (void *pixels);

	void playSound (int frame, int repeat);
	   
private:

	int mFrame;
	float mX, mY, mOldX, mOldY;
	int mAnimating;
	int mDrawn;
	float mSpeed;
	long mLastupdate;
	CSpriteFrame *mAnim;
	int mBuilt, mNumframes, mW, mH;
	//CSpriteBase *mSpriteBase;
	SDL_Surface *mBackreplacement;
	SDL_Surface *mScreen;
	// per a poder fer una sequencia concreta d'animacions
	int mfixframe;
	CSound *so;
};

#endif
